/*----- PROTECTED REGION ID(AxisG2Mps.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Mps.cpp
//
// description : C++ source for the AxisG2Mps class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               AxisG2Mps are implemented in this file.
//
// project :     AxisG2Mps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2Mps.h>
#include <AxisG2MpsClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps.cpp

/**
 *  AxisG2Mps class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  TryOFF        |  try_off
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  MPSStatus     |  Tango::DevString	Scalar
//  MPSHeartBeat  |  Tango::DevString	Scalar
//  AxisUnits     |  Tango::DevBoolean	Scalar
//  ExtStatus     |  Tango::DevString	Spectrum  ( max = 100)
//================================================================

namespace AxisG2Mps_ns
{
/*----- PROTECTED REGION ID(AxisG2Mps::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::AxisG2Mps()
 *	Description : Constructors for a Tango device
 *                implementing the classAxisG2Mps
 */
//--------------------------------------------------------
AxisG2Mps::AxisG2Mps(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(AxisG2Mps::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::constructor_1
}
//--------------------------------------------------------
AxisG2Mps::AxisG2Mps(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(AxisG2Mps::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::constructor_2
}
//--------------------------------------------------------
AxisG2Mps::AxisG2Mps(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(AxisG2Mps::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void AxisG2Mps::delete_device()
{
	DEBUG_STREAM << "AxisG2Mps::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	if (dp) delete dp;
	if ( *attr_MPSStatus_read ) delete[] *attr_MPSStatus_read;
	if ( *attr_MPSHeartBeat_read ) delete[] *attr_MPSHeartBeat_read;
	nick2idx_ro.clear();

	vector<string>::iterator it;
	for (it=MPSBit_dynAttr.begin(); it!= MPSBit_dynAttr.end(); ++it){
		remove_MPSBit_dynamic_attribute(*it);
	}
	MPSBit_dynAttr.clear();

        for (int i=0; i<100; i++){
                if (attr_ExtStatus_read[i] != NULL){
                        delete[] attr_ExtStatus_read[i];
                        attr_ExtStatus_read[i] = NULL;
                }
        }

	name2idx_mpsdata.clear();

	for (it=MPSRange_dynAttr.begin(); it!= MPSRange_dynAttr.end(); ++it){
		remove_MPSRange_dynamic_attribute(*it);
	}
	MPSRange_dynAttr.clear();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::delete_device
	delete[] attr_MPSStatus_read;
	delete[] attr_MPSHeartBeat_read;
	delete[] attr_AxisUnits_read;
	delete[] attr_ExtStatus_read;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void AxisG2Mps::init_device()
{
	DEBUG_STREAM << "AxisG2Mps::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::init_device_before) ENABLED START -----*/
	cout << "AxisG2Mps::init_device() create device " << device_name << endl;
	
	//	Initialization before get_device_property() call

	Tango::Database *db = Tango::Util::instance()->get_database();
	#ifdef _DBG_DB
		cout << db->get_info() << endl;
	#endif
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_MPSStatus_read = new Tango::DevString[1];
	attr_MPSHeartBeat_read = new Tango::DevString[1];
	attr_AxisUnits_read = new Tango::DevBoolean[1];
	attr_ExtStatus_read = new Tango::DevString[100];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(AxisG2Mps::init_device) ENABLED START -----*/
	
	//	Initialize device

	// MYCODE-START


	#ifdef __GNUC__
	#  include <features.h>
	#  if __GNUC_PREREQ(4,4)
	//      If  gcc_version >= 4.4
	//	already done
	#  else
                mapOfAxis["A"]=0;
                mapOfAxis["B"]=1;
                mapOfAxis["C"]=2;
                mapOfAxis["D"]=3;
                mapOfAxis["E"]=4;
                mapOfAxis["F"]=5;
                mapOfAxis["G"]=6;
                mapOfAxis["H"]=7;
	#  endif
	#endif

        bool init_device_ok = true;

        try {
                dp = new Tango::DeviceProxy(driver);
                cout << device_name << " connected to: " << driver << endl;
        } catch(Tango::DevFailed &e) {
                string ss( e.errors[0].desc );
                cout << device_name << " " << ss << endl;
                append_status(ss, true);
                init_device_ok &= false;
        } catch (...) {
                string ss("Exception on Tango::DeviceProxy(" + driver + ")!");
                cout << device_name << " " << ss << endl;
                append_status(ss, true);
                init_device_ok &= false;
        };

	*attr_MPSStatus_read = new char[STRING_SIZE];
	*attr_MPSHeartBeat_read = new char[STRING_SIZE];
	snprintf(*attr_MPSStatus_read, STRING_SIZE-1, " zzz ");
	snprintf(*attr_MPSHeartBeat_read, STRING_SIZE-1, " zzz ");

        //==================================================

	previous_mps_beat = -1;

        //==================================================

	for (size_t j=0; j<mPSStatusList.size(); j++ ){
		vector<string> a;
		MpsStatus_t s = { "", -1 };
		
		a = splitby(mPSStatusList[j].c_str(), ':');
		if ( a.size() != 2 ){
			init_device_ok = false;
		}

		s.name = a[0];
		s.value = atoi(a[1].c_str());

		_mps_status_.push_back(s);
	}
        //==================================================

        map<string, int>::iterator  mit;
        if ( outputBitList.size() != 0 ) {
                if ( !parseBitList(outputBitList, bits_ro, nick2idx_ro) ) {
                        init_device_ok = false;
                }
        }


        //==================================================
        for (int i=0; i<100; i++){
                attr_ExtStatus_read[i] = new char[STRING_SIZE];
                snprintf(attr_ExtStatus_read[i], STRING_SIZE, "-");
        }
        //==================================================

	//mpsdata

	for (int j = 0; j < 8 ; j++ ) mpsdata[j].axis = -1;
       	init_device_ok &= MpsData();

	std::vector<MpsInterval_t>::iterator mpsit;
  #if 0
	for (int j = 0; j < 8 ; j++ ) {
		if ( (mpsdata[j].axis != -1) && (mpsdata[j].axis < 8) ){
			cout << endl;
			cout << "mpsdata[" << j << "].axis            : " << AxisNames[mpsdata[j].axis] << endl;
			cout << "mpsdata[" << j << "].No_of_Intervals : " << mpsdata[j].No_of_Intervals << endl;
			for ( mpsit = mpsdata[j].MpsInterval.begin(); mpsit != mpsdata[j].MpsInterval.end(); mpsit++ ) {
				cout << "mpsdata[" << j << "].[" << 1+std::distance(mpsdata[j].MpsInterval.begin(), mpsit) << "]";
				cout << " min= " << (*mpsit).min ;
				cout << " max= " << (*mpsit).max ;
				cout << endl;
			}
		}
	}
	cout << endl;
  #endif
        //==================================================
	// AxisDevices

	for (int j = 0; j < 8 ; j++ ) {
		if ( (mpsdata[j].axis != -1) && (mpsdata[j].axis < 8) ){
			mpsdata[j].per = nan("");
			mpsdata[j].peo = nan("");
		}
	}

	if (axisDevices.size() != 0) *attr_AxisUnits_read = true;
	else *attr_AxisUnits_read = false;


	std::vector<string>::iterator axisDit;
	try {
		for (axisDit = axisDevices.begin(); axisDit != axisDevices.end(); axisDit++){
		
			Tango::DbData db_data;
			db_data.push_back(Tango::DbDatum("Channel"));
			db_data.push_back(Tango::DbDatum("PositionEncoderRatio"));
			db_data.push_back(Tango::DbDatum("PositionEncoderOffset"));
			db->get_device_property(*axisDit, db_data);
	
			string ch;
			double per, peo;
	
			if ( (db_data.size() == 3) && (!db_data[0].is_empty()) && (!db_data[1].is_empty()) && (!db_data[2].is_empty()) ){
				db_data[0] >> ch;
				db_data[1] >> per;
				db_data[2] >> peo;
				*attr_AxisUnits_read = true && *attr_AxisUnits_read;
			} else {
				per = nan("");
				peo = nan("");
				*attr_AxisUnits_read = false && *attr_AxisUnits_read;
			}
	
			mpsdata[mapOfAxis[ch]].per = per;
			mpsdata[mapOfAxis[ch]].peo = peo;
	
			cout << device_name << " ";
			cout << "db_data.size()=" << db_data.size() << " ";
			cout << "ch? "    << (db_data[0].is_empty()?"empty":"data") << " ";
			cout << "per? "   << (db_data[1].is_empty()?"empty":"data") << " ";
			cout << "peo? "   << (db_data[2].is_empty()?"empty":"data") << " ";
			cout << "| ";
			cout << *axisDit << " ch= " << ch << " per= " << per << " peo= " << peo << endl;
		}
	} catch (...) {
		cout << device_name << " " << " ERR DB " << endl;
	}

	for (int j = 0; j < 8 ; j++ ) {
		if ( (mpsdata[j].axis != -1) && (mpsdata[j].axis < 8) ){
			cout << endl;
			cout << device_name << endl;
			cout << "mpsdata[" << j << "].axis            : " << AxisNames[mpsdata[j].axis] << endl;
			cout << "mpsdata[" << j << "].No_of_Intervals : " << mpsdata[j].No_of_Intervals << endl;
			cout << "mpsdata[" << j << "].per : " << mpsdata[j].per << endl;
			cout << "mpsdata[" << j << "].peo : " << mpsdata[j].peo << endl;
			for ( mpsit = mpsdata[j].MpsInterval.begin(); mpsit != mpsdata[j].MpsInterval.end(); mpsit++ ) {
				cout << "mpsdata[" << j << "].[" << 1+std::distance(mpsdata[j].MpsInterval.begin(), mpsit) << "]";
				cout << " min= " << (*mpsit).min ;
				cout << " max= " << (*mpsit).max ;
				cout << endl;
			}
		}
	}
	cout << endl;

        //==================================================

        if (init_device_ok) {
                set_state(Tango::ON);
                set_status("Initialization done.");
        } else {
                set_state(Tango::FAULT);
        }
        // MYCODE-END

	
	cout << device_name << ":  END of INIT" << endl << endl;
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::init_device
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void AxisG2Mps::get_device_property()
{
	/*----- PROTECTED REGION ID(AxisG2Mps::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Driver"));
	dev_prop.push_back(Tango::DbDatum("AxisDevices"));
	dev_prop.push_back(Tango::DbDatum("OutputBitList"));
	dev_prop.push_back(Tango::DbDatum("MPSStatusList"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on AxisG2MpsClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		AxisG2MpsClass	*ds_class =
			(static_cast<AxisG2MpsClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Driver from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  driver;
		else {
			//	Try to initialize Driver from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  driver;
		}
		//	And try to extract Driver value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  driver;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisDevices from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisDevices;
		else {
			//	Try to initialize AxisDevices from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisDevices;
		}
		//	And try to extract AxisDevices value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisDevices;

		//	Try to initialize OutputBitList from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  outputBitList;
		else {
			//	Try to initialize OutputBitList from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  outputBitList;
		}
		//	And try to extract OutputBitList value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  outputBitList;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize MPSStatusList from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  mPSStatusList;
		else {
			//	Try to initialize MPSStatusList from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  mPSStatusList;
		}
		//	And try to extract MPSStatusList value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  mPSStatusList;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(AxisG2Mps::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void AxisG2Mps::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		string	status(get_status());
		status += tms.str();
		set_status(status);
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(AxisG2Mps::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void AxisG2Mps::always_executed_hook()
{
	DEBUG_STREAM << "AxisG2Mps::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"AxisG2Mps::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(AxisG2Mps::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void AxisG2Mps::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2Mps::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute MPSStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Mps::read_MPSStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_MPSStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::read_MPSStatus) ENABLED START -----*/

	try {
		int mps_st = atoi( write_read("MPSSt=?").c_str() );

		bzero(*attr_MPSStatus_read, STRING_SIZE);

		std::vector<MpsStatus_t>::iterator it;

		for ( it = _mps_status_.begin(); it != _mps_status_.end(); it++ ){
			if ( (*it).value == mps_st ) {
				snprintf(*attr_MPSStatus_read, STRING_SIZE-1, "%s", (*it).name.c_str());
				break;
			}
		}
		//	Set the attribute value
		attr.set_value(attr_MPSStatus_read);
	} catch (...) {
		attr.set_quality(Tango::ATTR_INVALID);
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_MPSStatus
}
//--------------------------------------------------------
/**
 *	Read attribute MPSHeartBeat related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Mps::read_MPSHeartBeat(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_MPSHeartBeat(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::read_MPSHeartBeat) ENABLED START -----*/

	// attributo polled !!
	stringstream ss("");

	try {
		long current_mps_beat = atol( write_read("BEAT=?").c_str() );
		ss << "HeartBeat: " << current_mps_beat;
	
		if(previous_mps_beat != current_mps_beat) {
	
	                        heart_beat_read = AxisG2MpsHeartBeat_ns::OK;
				previous_mps_beat = current_mps_beat;
	        		set_state(Tango::ON);
		} else {
	                        heart_beat_read = AxisG2MpsHeartBeat_ns::BLOCKED;
	        		set_state(Tango::ALARM);
				ss << " BLOCKED!";
		}
	
		bzero(*attr_MPSHeartBeat_read, STRING_SIZE);
		snprintf(*attr_MPSHeartBeat_read, STRING_SIZE-1, "%s", AxisG2MpsHeartBeat_ns::HeartBeatStateName[heart_beat_read]);
	
	        set_status(ss.str());
	
		try {
			ss.str("");
			ss << "Axis: ";
	              	append_status(ss.str(), true);
	
			for (int j = 0; j < 8 ; j++ ) {
				if ( (mpsdata[j].axis != -1) && (mpsdata[j].axis < 8) && mpsdata[j].No_of_Intervals > 0 ){
					char buff[100];
					bzero(buff, 100);
					snprintf(buff, 100, "AX[%d]=?", mpsdata[j].axis);
					long ccx = atol( write_read(buff).c_str() );
	
					ss.str("");
					ss << "------ " << AxisNames[mpsdata[j].axis];
					if ( !(ccx & 0x10000) ) {
	        				set_state(Tango::ALARM);
						ss << " not";
					}
					ss << " inited";
	                		append_status(ss.str(), true);
				}
			}
		} catch(...) {
		}
	
		//	Set the attribute value
		attr.set_value(attr_MPSHeartBeat_read);
	} catch (...) {
		attr.set_quality(Tango::ATTR_INVALID);
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_MPSHeartBeat
}
//--------------------------------------------------------
/**
 *	Read attribute AxisUnits related method
 *	Description: true = MPSRange uses axis units
 *               false = MPSRange uses encoder units
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Mps::read_AxisUnits(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_AxisUnits(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::read_AxisUnits) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_AxisUnits_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_AxisUnits
}
//--------------------------------------------------------
/**
 *	Read attribute ExtStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
//--------------------------------------------------------
void AxisG2Mps::read_ExtStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::read_ExtStatus) ENABLED START -----*/

        std::stringstream ss;

        int riga = 0;
        int howmany = 0;

        ss.str("");
        ss << " = ";
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;


        //      Set the attribute value
        if ( howmany > 100 ) howmany = 100;
        attr.set_value(attr_ExtStatus_read, howmany);


	//	Set the attribute value
	//attr.set_value(attr_ExtStatus_read, 100);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_ExtStatus
}

//--------------------------------------------------------
/**
 *	Read attribute MPSRange related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Mps::read_MPSRange(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_MPSRange(Tango::Attribute &attr) entering... " << endl;
	Tango::DevString	*att_value = get_MPSRange_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(AxisG2Mps::read_MPSRange) ENABLED START -----*/


	Attr_MpsInterval_t amps = name2idx_mpsdata[attr.get_name()];

	MpsInterval_t mi = mpsdata[amps.axis].MpsInterval[amps.idx];

	std::stringstream ss;

	if (*attr_AxisUnits_read) {
		ss << (mpsdata[amps.axis].per * mi.min + mpsdata[amps.axis].peo) << ";";
		ss << (mpsdata[amps.axis].per * mi.max + mpsdata[amps.axis].peo) ;
	} else {
		ss << mi.min << ";" << mi.max;
	}

	CORBA::string_free(att_value[0]);
        att_value[0] = CORBA::string_dup( ss.str().c_str() );

	//	Set the attribute value
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_MPSRange
}
//--------------------------------------------------------
/**
 *	Read attribute MPSBit related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Mps::read_MPSBit(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Mps::read_MPSBit(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_MPSBit_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(AxisG2Mps::read_MPSBit) ENABLED START -----*/

        try {
                *att_value = readBit( bits_ro[nick2idx_ro[attr.get_name()]].bit, true );

		//	Set the attribute value
		attr.set_value(att_value);
        } catch (...) {
		attr.set_quality(Tango::ATTR_INVALID);
        }

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::read_MPSBit
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Mps::add_dynamic_attributes()
{
	//	Example to add dynamic attribute:
	//	Copy inside the following protected area to create instance(s) at startup.
	//	add_MPSRange_dynamic_attribute("MyMPSRangeAttribute");
	//	add_MPSBit_dynamic_attribute("MyMPSBitAttribute");
	
	/*----- PROTECTED REGION ID(AxisG2Mps::add_dynamic_attributes) ENABLED START -----*/
	//cout << "AxisG2Mps::add_dynamic_attributes() create device " << device_name << endl;
	
	//	Add your own code to create and add dynamic attributes if any
        vector<bit_t>::iterator it;

        for ( it = bits_ro.begin(); it != bits_ro.end(); it ++ ){
                add_MPSBit_dynamic_attribute((*it).nickname);
		MPSBit_dynAttr.push_back((*it).nickname);
        }

	stringstream att_name;
	std::vector<MpsInterval_t>::iterator mpsit;
	for (int j = 0; j < 8 ; j++ ) {
		if ( (mpsdata[j].axis != -1) && (mpsdata[j].axis < 8) ){
			for ( mpsit = mpsdata[j].MpsInterval.begin(); mpsit != mpsdata[j].MpsInterval.end(); mpsit++ ) {
				att_name.str("");
				att_name << "MPS" << AxisNames[mpsdata[j].axis];
				att_name << "Range_" << 1+std::distance(mpsdata[j].MpsInterval.begin(), mpsit);
				MPSRange_dynAttr.push_back(att_name.str());
				add_MPSRange_dynamic_attribute(att_name.str());
				Attr_MpsInterval_t amps;
				amps.axis = mpsdata[j].axis;
				amps.idx  = std::distance(mpsdata[j].MpsInterval.begin(), mpsit);
				name2idx_mpsdata[att_name.str()]=amps;

				string s(att_name.str());
				Tango::DevString *att_value = get_MPSRange_data_ptr(s);
				//cout << "!" << att_value[0] << "!" << strlen(att_value[0]) << endl;
			        att_value[0] = CORBA::string_dup(" z;z ");
			}
		}
	}

	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command TryOFF related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void AxisG2Mps::try_off()
{
	DEBUG_STREAM << "AxisG2Mps::TryOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Mps::try_off) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::try_off
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Mps::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(AxisG2Mps::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::add_dynamic_commands
}

/*----- PROTECTED REGION ID(AxisG2Mps::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::namespace_ending
} //	namespace
