/*----- PROTECTED REGION ID(AxisG2Mps.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Mps.h
//
// description : Include file for the AxisG2Mps class
//
// project :     AxisG2Mps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2Mps_H
#define AxisG2Mps_H

#include <tango.h>

#include "libaxisutils.h"

#include "AxisG2MpsTypes.h"


/*----- PROTECTED REGION END -----*/	//	AxisG2Mps.h

/**
 *  AxisG2Mps class description:
 *    
 */

namespace AxisG2Mps_ns
{
/*----- PROTECTED REGION ID(AxisG2Mps::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::Additional Class Declarations

class AxisG2Mps : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(AxisG2Mps::Data Members) ENABLED START -----*/

//	Add your own data members
private:
        Tango::DeviceProxy      *dp;

	static const int MAX_RANGE_NUMBER = 30;
	static const int MAX_TRYOFF_NUMBER = 10;
	static const std::size_t STRING_SIZE = 256;

        std::string mps_status;
        AxisG2MpsHeartBeat_ns::HeartBeatState_t heart_beat_read;

	long previous_mps_beat;

	std::vector<MpsStatus_t> _mps_status_;

	vector<bit_t>           bits_ro;
        map<string, int>        nick2idx_ro;
	vector<string>		MPSBit_dynAttr;

	MpsData_t		mpsdata[8];
        map<string, Attr_MpsInterval_t>        name2idx_mpsdata;
	vector<string>		MPSRange_dynAttr;


/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::Data Members

//	Device property data members
public:
	//	Driver:	
	string	driver;
	//	AxisDevices:	nickName;tangoDevice
	vector<string>	axisDevices;
	//	OutputBitList:	nickName:bit_no
	vector<string>	outputBitList;
	//	MPSStatusList:	
	vector<string>	mPSStatusList;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_MPSStatus_read;
	Tango::DevString	*attr_MPSHeartBeat_read;
	Tango::DevBoolean	*attr_AxisUnits_read;
	Tango::DevString	*attr_ExtStatus_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Mps(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Mps(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	AxisG2Mps(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~AxisG2Mps() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2Mps::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute MPSStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_MPSStatus(Tango::Attribute &attr);
	virtual bool is_MPSStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute MPSHeartBeat related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_MPSHeartBeat(Tango::Attribute &attr);
	virtual bool is_MPSHeartBeat_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisUnits related methods
 *	Description: true = MPSRange uses axis units
 *               false = MPSRange uses encoder units
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_AxisUnits(Tango::Attribute &attr);
	virtual bool is_AxisUnits_allowed(Tango::AttReqType type);
/**
 *	Attribute ExtStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
	virtual void read_ExtStatus(Tango::Attribute &attr);
	virtual bool is_ExtStatus_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute MPSRange related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar
	 */
	virtual void read_MPSRange(Tango::Attribute &attr);
	virtual bool is_MPSRange_allowed(Tango::AttReqType type);
	void add_MPSRange_dynamic_attribute(string attname);
	void remove_MPSRange_dynamic_attribute(string attname);
	Tango::DevString *get_MPSRange_data_ptr(string &name);
	map<string,Tango::DevString>	   MPSRange_data;

	/**
	 *	Attribute MPSBit related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_MPSBit(Tango::Attribute &attr);
	virtual bool is_MPSBit_allowed(Tango::AttReqType type);
	void add_MPSBit_dynamic_attribute(string attname);
	void remove_MPSBit_dynamic_attribute(string attname);
	Tango::DevBoolean *get_MPSBit_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   MPSBit_data;

	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Mps::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command TryOFF related method
	 *	Description: 
	 *
	 */
	virtual void try_off();
	virtual bool is_TryOFF_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Mps::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(AxisG2Mps::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

	void update_mps_heart_status();
	string write_read(string input_str);
	void exception_handler(Tango::DevFailed &ex, Tango::DevState new_state, const std::string base_msg);
	bool parseBitList(vector<string>& BitList,  vector<bit_t>& bits, map<string, int>& nick2idx);
	bool readBit(short bit, bool rw);
	void ExtStatus(Tango::DevString *extstatusattr, int *riga, string msg);
	bool MpsData();
	long RW(string query);


/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::Additional Method prototypes
};

/*----- PROTECTED REGION ID(AxisG2Mps::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::Additional Classes Definitions

}	//	End of namespace

#endif   //	AxisG2Mps_H
