/*----- PROTECTED REGION ID(AxisG2MpsClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2MpsClass.cpp
//
// description : C++ source for the AxisG2MpsClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the AxisG2Mps once per process.
//
// project :     Galilmps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2MpsClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass.cpp

//-------------------------------------------------------------------
/**
 *	Create AxisG2MpsClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AxisG2Mps_class(const char *name) {
		return AxisG2Mps_ns::AxisG2MpsClass::init(name);
	}
}

namespace AxisG2Mps_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AxisG2MpsClass *AxisG2MpsClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::AxisG2MpsClass(string &s)
 * description : 	constructor for the AxisG2MpsClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AxisG2MpsClass::AxisG2MpsClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering AxisG2MpsClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AxisG2MpsClass::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::constructor

	cout2 << "Leaving AxisG2MpsClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::~AxisG2MpsClass()
 * description : 	destructor for the AxisG2MpsClass
 */
//--------------------------------------------------------
AxisG2MpsClass::~AxisG2MpsClass()
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AxisG2MpsClass *AxisG2MpsClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AxisG2MpsClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AxisG2MpsClass *AxisG2MpsClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		TryOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *TryOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "TryOFFClass::execute(): arrived" << endl;
	((static_cast<AxisG2Mps *>(device))->try_off());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2MpsClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2MpsClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2MpsClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void AxisG2MpsClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "Driver";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisDevices";
	prop_desc = "nickName;tangoDevice";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "OutputBitList";
	prop_desc = "nickName:bit_no";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MPSStatusList";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AxisG2MpsClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Galilmps");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void AxisG2MpsClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AxisG2Mps(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AxisG2Mps *dev = static_cast<AxisG2Mps *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AxisG2MpsClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void AxisG2MpsClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::attribute_factory_before
	//	Attribute : MPSStatus
	MPSStatusAttrib	*mpsstatus = new MPSStatusAttrib();
	Tango::UserDefaultAttrProp	mpsstatus_prop;
	//	description	not set for MPSStatus
	//	label	not set for MPSStatus
	//	unit	not set for MPSStatus
	//	standard_unit	not set for MPSStatus
	//	display_unit	not set for MPSStatus
	//	format	not set for MPSStatus
	//	max_value	not set for MPSStatus
	//	min_value	not set for MPSStatus
	//	max_alarm	not set for MPSStatus
	//	min_alarm	not set for MPSStatus
	//	max_warning	not set for MPSStatus
	//	min_warning	not set for MPSStatus
	//	delta_t	not set for MPSStatus
	//	delta_val	not set for MPSStatus
	
	mpsstatus->set_default_properties(mpsstatus_prop);
	//	Not Polled
	mpsstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(mpsstatus);

	//	Attribute : MPSHeartBeat
	MPSHeartBeatAttrib	*mpsheartbeat = new MPSHeartBeatAttrib();
	Tango::UserDefaultAttrProp	mpsheartbeat_prop;
	//	description	not set for MPSHeartBeat
	//	label	not set for MPSHeartBeat
	//	unit	not set for MPSHeartBeat
	//	standard_unit	not set for MPSHeartBeat
	//	display_unit	not set for MPSHeartBeat
	//	format	not set for MPSHeartBeat
	//	max_value	not set for MPSHeartBeat
	//	min_value	not set for MPSHeartBeat
	//	max_alarm	not set for MPSHeartBeat
	//	min_alarm	not set for MPSHeartBeat
	//	max_warning	not set for MPSHeartBeat
	//	min_warning	not set for MPSHeartBeat
	//	delta_t	not set for MPSHeartBeat
	//	delta_val	not set for MPSHeartBeat
	
	mpsheartbeat->set_default_properties(mpsheartbeat_prop);
	mpsheartbeat->set_polling_period(1000);
	mpsheartbeat->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(mpsheartbeat);

	//	Attribute : AxisUnits
	AxisUnitsAttrib	*axisunits = new AxisUnitsAttrib();
	Tango::UserDefaultAttrProp	axisunits_prop;
	axisunits_prop.set_description("true = MPSRange uses axis units\nfalse = MPSRange uses encoder units");
	//	label	not set for AxisUnits
	//	unit	not set for AxisUnits
	//	standard_unit	not set for AxisUnits
	//	display_unit	not set for AxisUnits
	//	format	not set for AxisUnits
	//	max_value	not set for AxisUnits
	//	min_value	not set for AxisUnits
	//	max_alarm	not set for AxisUnits
	//	min_alarm	not set for AxisUnits
	//	max_warning	not set for AxisUnits
	//	min_warning	not set for AxisUnits
	//	delta_t	not set for AxisUnits
	//	delta_val	not set for AxisUnits
	
	axisunits->set_default_properties(axisunits_prop);
	//	Not Polled
	axisunits->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axisunits);

	//	Attribute : ExtStatus
	ExtStatusAttrib	*extstatus = new ExtStatusAttrib();
	Tango::UserDefaultAttrProp	extstatus_prop;
	//	description	not set for ExtStatus
	//	label	not set for ExtStatus
	//	unit	not set for ExtStatus
	//	standard_unit	not set for ExtStatus
	//	display_unit	not set for ExtStatus
	//	format	not set for ExtStatus
	//	max_value	not set for ExtStatus
	//	min_value	not set for ExtStatus
	//	max_alarm	not set for ExtStatus
	//	min_alarm	not set for ExtStatus
	//	max_warning	not set for ExtStatus
	//	min_warning	not set for ExtStatus
	//	delta_t	not set for ExtStatus
	//	delta_val	not set for ExtStatus
	
	extstatus->set_default_properties(extstatus_prop);
	//	Not Polled
	extstatus->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(extstatus);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(AxisG2MpsClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void AxisG2MpsClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::pipe_factory_before
	/*----- PROTECTED REGION ID(AxisG2MpsClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void AxisG2MpsClass::command_factory()
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::command_factory_before


	//	Command TryOFF
	TryOFFClass	*pTryOFFCmd =
		new TryOFFClass("TryOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pTryOFFCmd);

	/*----- PROTECTED REGION ID(AxisG2MpsClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void AxisG2MpsClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(AxisG2MpsClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		AxisG2MpsClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AxisG2MpsClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AxisG2Mps *dev = static_cast<AxisG2Mps *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AxisG2MpsClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2MpsClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *AxisG2MpsClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(AxisG2MpsClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::Additional Methods
} //	namespace
