/*----- PROTECTED REGION ID(AxisG2MpsClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2MpsClass.h
//
// description : Include for the AxisG2Mps root class.
//               This class is the singleton class for
//                the AxisG2Mps device class.
//               It contains all properties and methods which the 
//               AxisG2Mps requires only once e.g. the commands.
//
// project :     Galilmps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2MpsClass_H
#define AxisG2MpsClass_H

#include <tango.h>
#include <AxisG2Mps.h>


/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass.h


namespace AxisG2Mps_ns
{
/*----- PROTECTED REGION ID(AxisG2MpsClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute MPSStatus class definition
class MPSStatusAttrib: public Tango::Attr
{
public:
	MPSStatusAttrib():Attr("MPSStatus",
			Tango::DEV_STRING, Tango::READ) {};
	~MPSStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_MPSStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_MPSStatus_allowed(ty);}
};

//	Attribute MPSHeartBeat class definition
class MPSHeartBeatAttrib: public Tango::Attr
{
public:
	MPSHeartBeatAttrib():Attr("MPSHeartBeat",
			Tango::DEV_STRING, Tango::READ) {};
	~MPSHeartBeatAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_MPSHeartBeat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_MPSHeartBeat_allowed(ty);}
};

//	Attribute AxisUnits class definition
class AxisUnitsAttrib: public Tango::Attr
{
public:
	AxisUnitsAttrib():Attr("AxisUnits",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~AxisUnitsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_AxisUnits(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_AxisUnits_allowed(ty);}
};

//	Attribute ExtStatus class definition
class ExtStatusAttrib: public Tango::SpectrumAttr
{
public:
	ExtStatusAttrib():SpectrumAttr("ExtStatus",
			Tango::DEV_STRING, Tango::READ, 100) {};
	~ExtStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_ExtStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_ExtStatus_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute MPSRange class definition
class MPSRangeAttrib: public Tango::Attr
{
public:
	MPSRangeAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_STRING, Tango::READ) {};
	~MPSRangeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_MPSRange(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_MPSRange_allowed(ty);}
};

//	Attribute MPSBit class definition
class MPSBitAttrib: public Tango::Attr
{
public:
	MPSBitAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~MPSBitAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Mps *>(dev))->read_MPSBit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Mps *>(dev))->is_MPSBit_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command TryOFF class definition
class TryOFFClass : public Tango::Command
{
public:
	TryOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	TryOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~TryOFFClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Mps *>(dev))->is_TryOFF_allowed(any);}
};


/**
 *	The AxisG2MpsClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AxisG2MpsClass : public Tango::DeviceClass
#else
class AxisG2MpsClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AxisG2MpsClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2MpsClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AxisG2MpsClass *init(const char *);
		static AxisG2MpsClass *instance();
		~AxisG2MpsClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AxisG2MpsClass(string &);
		static AxisG2MpsClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	AxisG2Mps_H
