/*----- PROTECTED REGION ID(AxisG2Mps::DynAttrUtils.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2MpsDynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the AxisG2Mps class
//
// project :     Galilmps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2Mps.h>
#include <AxisG2MpsClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::DynAttrUtils.cpp

//================================================================
//  Attributes managed are:
//================================================================
//  MPSRange  |  Tango::DevString	Scalar
//  MPSBit    |  Tango::DevBoolean	Scalar
//================================================================

//	For compatibility reason, this file (AxisG2MpsDynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//================================================================

namespace AxisG2Mps_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a MPSRange dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void AxisG2Mps::add_MPSRange_dynamic_attribute(string attname)
{
	//	Attribute : MPSRange
	MPSRangeAttrib	*mpsrange = new MPSRangeAttrib(attname);
	Tango::UserDefaultAttrProp	mpsrange_prop;
	//	description	not set for MPSRange
	//	label	not set for MPSRange
	//	unit	not set for MPSRange
	//	standard_unit	not set for MPSRange
	//	display_unit	not set for MPSRange
	//	format	not set for MPSRange
	//	max_value	not set for MPSRange
	//	min_value	not set for MPSRange
	//	max_alarm	not set for MPSRange
	//	min_alarm	not set for MPSRange
	//	max_warning	not set for MPSRange
	//	min_warning	not set for MPSRange
	//	delta_t	not set for MPSRange
	//	delta_val	not set for MPSRange
	
	/*----- PROTECTED REGION ID(AxisG2Mps::att_MPSRange_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::att_MPSRange_dynamic_attribute
	mpsrange->set_default_properties(mpsrange_prop);
	//	Not Polled
	mpsrange->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	char array[1];
	array[0] = '\0';
	MPSRange_data.insert(make_pair(attname, array));
	add_attribute(mpsrange);
}
//--------------------------------------------------------
/**
 *	remove a MPSRange dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void AxisG2Mps::remove_MPSRange_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevString>::iterator ite;
    if ((ite=MPSRange_data.find(attname))!=MPSRange_data.end())
    {
    	/*----- PROTECTED REGION ID(AxisG2Mps::remove_MPSRange_dynamic_attribute) ENABLED START -----*/
	#ifdef _DBG_REMOVE_DYN_ATTRS
		cout << device_name << " ============= remove_MPSRange_dynamic_attribute ============== " << attname << endl;
	#endif
	if (ite->second) CORBA::string_free(ite->second);
    	
    	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::remove_MPSRange_dynamic_attribute
		MPSRange_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a MPSBit dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void AxisG2Mps::add_MPSBit_dynamic_attribute(string attname)
{
	//	Attribute : MPSBit
	MPSBitAttrib	*mpsbit = new MPSBitAttrib(attname);
	Tango::UserDefaultAttrProp	mpsbit_prop;
	//	description	not set for MPSBit
	//	label	not set for MPSBit
	//	unit	not set for MPSBit
	//	standard_unit	not set for MPSBit
	//	display_unit	not set for MPSBit
	//	format	not set for MPSBit
	//	max_value	not set for MPSBit
	//	min_value	not set for MPSBit
	//	max_alarm	not set for MPSBit
	//	min_alarm	not set for MPSBit
	//	max_warning	not set for MPSBit
	//	min_warning	not set for MPSBit
	//	delta_t	not set for MPSBit
	//	delta_val	not set for MPSBit
	
	/*----- PROTECTED REGION ID(AxisG2Mps::att_MPSBit_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::att_MPSBit_dynamic_attribute
	mpsbit->set_default_properties(mpsbit_prop);
	//	Not Polled
	mpsbit->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	MPSBit_data.insert(make_pair(attname, false));
	add_attribute(mpsbit);
}
//--------------------------------------------------------
/**
 *	remove a MPSBit dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void AxisG2Mps::remove_MPSBit_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=MPSBit_data.find(attname))!=MPSBit_data.end())
    {
    	/*----- PROTECTED REGION ID(AxisG2Mps::remove_MPSBit_dynamic_attribute) ENABLED START -----*/
	#ifdef _DBG_REMOVE_DYN_ATTRS
		cout << device_name << " ============= remove_MPSBit_dynamic_attribute ============== " << attname << endl;
	#endif
    	
    	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::remove_MPSBit_dynamic_attribute
		MPSBit_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer 
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on MPSRange data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevString *AxisG2Mps::get_MPSRange_data_ptr(string &name)
{
	map<string,Tango::DevString>::iterator ite;
    if ((ite=MPSRange_data.find(name))==MPSRange_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"AxisG2Mps::get_MPSRange_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on MPSBit data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *AxisG2Mps::get_MPSBit_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=MPSBit_data.find(name))==MPSBit_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"AxisG2Mps::get_MPSBit_data_ptr()");
    }
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================


} //	namespace
