/*----- PROTECTED REGION ID(AxisG2MpsStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2MpsStateMachine.cpp
//
// description : State machine file for the AxisG2Mps class
//
// project :     Galilmps
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <AxisG2Mps.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::AxisG2MpsStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace AxisG2Mps_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_MPSStatus_allowed()
 *	Description : Execution allowed for MPSStatus attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_MPSStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MPSStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::MPSStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::MPSStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_MPSHeartBeat_allowed()
 *	Description : Execution allowed for MPSHeartBeat attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_MPSHeartBeat_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MPSHeartBeat attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::MPSHeartBeatStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::MPSHeartBeatStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_AxisUnits_allowed()
 *	Description : Execution allowed for AxisUnits attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_AxisUnits_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AxisUnits attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::AxisUnitsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::AxisUnitsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_ExtStatus_allowed()
 *	Description : Execution allowed for ExtStatus attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_ExtStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ExtStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::ExtStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::ExtStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_MPSRange_allowed()
 *	Description : Execution allowed for MPSRange attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_MPSRange_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MPSRange attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::MPSRangeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::MPSRangeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_MPSBit_allowed()
 *	Description : Execution allowed for MPSBit attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_MPSBit_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MPSBit attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Mps::MPSBitStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::MPSBitStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Mps::is_TryOFF_allowed()
 *	Description : Execution allowed for TryOFF attribute
 */
//--------------------------------------------------------
bool AxisG2Mps::is_TryOFF_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for TryOFF command.
	/*----- PROTECTED REGION ID(AxisG2Mps::TryOFFStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::TryOFFStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(AxisG2Mps::AxisG2MpsStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::AxisG2MpsStateAllowed.AdditionalMethods

}	//	End of namespace
