#include <AxisG2Mps.h>

namespace AxisG2MpsHeartBeat_ns {

typedef enum {
	OK,
	BLOCKED
} HeartBeatState_t;

const char * const HeartBeatStateName[] = {
        "OK",
	"BLOCKED"
};


} //namespace

namespace AxisG2Mps_ns {

typedef struct {
	string name;
	int value;
} MpsStatus_t;

// BitList: array of.....   nikname:bitNo

typedef struct {
        string nickname;
        short  bit;
        short  index;
} bit_t;


//============

typedef struct {
	long min;
	long max;
} MpsInterval_t;

typedef struct {
	int axis; 		// 0=A, 1=B, etc...
	int No_of_Intervals;
	std::vector<MpsInterval_t> MpsInterval;
	double per, peo;
} MpsData_t;

typedef enum {
	A = 0,
	B,
	C,
	D,
	E,
	F,
	G,
	H
} Axis_No_t;

const char * const AxisNames[] = { "A", "B", "C", "D", "E", "F", "G", "H" };

#ifdef __GNUC__
#  include <features.h>
#  if __GNUC_PREREQ(4,4)
//      If  gcc_version >= 4.4
static std::map<std::string, int> mapOfAxis = {
		{"A",0},
		{"B",1},
		{"C",2},
		{"D",3},
		{"E",4},
		{"F",5},
		{"G",6},
		{"H",7}
};
#  else
static std::map<std::string, int> mapOfAxis;
#  endif
#endif

typedef struct {
	int axis;
	int idx;
} Attr_MpsInterval_t;

} //namespace
