#include <AxisG2Mps.h>
namespace AxisG2Mps_ns {

long AxisG2Mps::RW(string query){
	Tango::DeviceData Din, Dout;
	Tango::DevString data;
        string resp;
	long val;
	int ret;

       	data = CORBA::string_dup(query.c_str());
      	Din << data;
	CORBA::string_free(data);

       	try {
               	Dout = dp->command_inout("WriteRead", Din);
       	} catch(Tango::DevFailed &e) {
               	string ss( e.errors[0].desc );
               	cout << ss << endl;
               	append_status(ss, true);
               	throw;
       	} catch (...) {
               	string ss("Exception on Tango::DeviceProxy(" + driver + ")!");
               	cout << ss << endl;
               	append_status(ss, true);
               	throw;
       	};
        Dout >> resp;
        //cout << resp << endl;
        ret = sscanf(resp.c_str(), "%ld", &val);
	if ( ret == 1) return val;
	else throw;
}


bool AxisG2Mps::MpsData() {

        int ax, ax_intvl;
	std::stringstream ss;

	char MPSAXIS[] =  "XYZ";

	for (unsigned int k = 0; k < strlen(MPSAXIS); k++ ){

		ss.str("");
		//cout << "M" << MPSAXIS[k] << "=?" << endl;
        	ss << "M" << MPSAXIS[k] << "=?";
		try {
			ax = RW(ss.str());
		} catch (...) {
			return false;
		}
		cout << ss.str() << " ... =" << ax << endl;

		if ( (ax>=0) && (ax<=7) ){
			ss.str("");
			//cout << "M" << MPSAXIS[k] << "I=?" << endl;
        		ss << "M" << MPSAXIS[k] << "I=?";
			try {
				ax_intvl = RW(ss.str());
			} catch (...) {
				return false;
			}
			cout << ss.str() << " ... =" << ax_intvl << endl;

			mpsdata[ax].axis = ax;
			mpsdata[ax].No_of_Intervals = ax_intvl;

			if (ax_intvl>0){
				for (int j = 1; j <= ax_intvl; j++ ){
					MpsInterval_t mi;
					ss.str("");
        				ss << "M" << MPSAXIS[k] << j << "[0]=?";
					//cout << ss.str() << endl;
					try {
						mi.min = RW(ss.str());
					} catch (...) {
                                		return false;
                        		}
					ss.str("");
        				ss << "M" << MPSAXIS[k] << j << "[1]=?";
					//cout << ss.str() << endl;
					try {
						mi.max = RW(ss.str());
					} catch (...) {
                                		return false;
                        		}
					mpsdata[ax].MpsInterval.push_back(mi);
				}
			}
		} else return false;
	} // for MPSAXIS

	return true;
}

} // namespace
