#include <AxisG2Mps.h>

namespace AxisG2Mps_ns {

bool AxisG2Mps::readBit(short bit, bool rw){
	
        stringstream ss("");
        Tango::DeviceData Din, Dout;
        Tango::DevString data;
        string resp;
        int lbit, ret;

	if (rw) ss << "MG @OUT[" << bit << "]";
	else    ss << "MG @IN[" << bit << "]";

        data = CORBA::string_dup(ss.str().c_str());
        Din << data;
	CORBA::string_free(data);

        try {
                Dout = dp->command_inout("WriteRead", Din);
        	//cout << Dout << endl;
        	Dout >> resp;
        	//cout << resp << endl;
        	ret = sscanf(resp.c_str(), "%d", &lbit);
        	if (ret == 1){
                	switch (lbit){
                        	default:
                        	case 0: return false; break;
                        	case 1: return true; break;
                	}
        	} else throw -1;
        } catch(Tango::DevFailed &e) {
                string s( e.errors[0].desc );
                //cout << s << endl;
		throw;
        } catch(...) {
		throw;
	}

	return false;
}

} //namespace
