#include <AxisG2Mps.h>
#include <ctime>

namespace AxisG2Mps_ns
{
string AxisG2Mps::write_read(string input_str)
{
	DEBUG_STREAM << "AxisG2Mps::write_read()  - " << device_name << endl;

	Tango::DeviceData input_devdata, output_devdata;
	input_devdata << input_str;

	try {
		output_devdata = dp->command_inout("WriteRead", input_devdata);

	} catch(Tango::DevFailed &ex) {

    		exception_handler(ex, Tango::FAULT,"AxisG2Mps::write_read()");
		throw;
    	} catch(...) {
		throw;
	}

	string output_str;
	output_devdata >> output_str;

	string unwanted_char;
	unwanted_char += 0xA; //Line feed
	unwanted_char += 0xD; //Carriage return
	unwanted_char += 0x20; //Space

	size_t pos = output_str.find_first_of(unwanted_char);
	while(pos != string::npos) {
            output_str.erase(pos,1);
            pos = output_str.find_first_of(unwanted_char);
	}

	if((pos = output_str.find_last_of(0x3A)) != string::npos) { //removing last ':'
		output_str.erase(pos,1);
	}

	return output_str;
}

	/*----- PROTECTED REGION END -----*/	//	AxisG2Mps::namespace_ending
} //	namespace

